#include "pan_tompkins.h"

void arrhythmia_detection(int32_t * signal_in_temp, int32_t * detected, int32_t * bpf, int32_t * peak_index_out, int32_t * pvc_index_out
#ifdef MATLAB_MEX_FILE 
       , int32_t * t1_db, int32_t * t2_db
#endif
        ){

	uint16_t j;
    static int32_t hp_5s_index=FS5-1;
    static int32_t peaks_index=0;
    static volatile int32_t prev_peak_loc=-1;
    static volatile int32_t curr_peak_loc=-1;
    static volatile int32_t index_curr=0;
    int32_t signal_in[SENSOR_BUFFER];
    int32_t signal_temp[SENSOR_BUFFER];
    int32_t highpass[SENSOR_BUFFER];
    int32_t wavelet[SENSOR_BUFFER];
    static int32_t signal_in_5s[FS5] = {0};
    static int32_t highpass_5s[FS5] = {0};
    static int32_t int_5s[FS5] = {0};
    static int32_t wavelet_5s[FS5] = {0};
    static float32_t zk_pvc[peaks_size] = {0};
    static int32_t T1[T1_max_length] = {0};
    static int32_t T2[T2_max_length] = {0};

	static int32_t wavelet_buff[WAVE_size] = {0};
	static int32_t lp_circ_buff[LP_size] = {0};
	static int32_t hp_circ_buff[HP_size] = {0};
	static int32_t diff_circ_buff[diff_size] = {0};
	static int32_t int_circ_buff[int_size] = {0};
	static int32_t template_found=0;
	static int32_t amp_mean=0, interval_mean=0, sendMessage=0;
	static int32_t highpass_5s_peak_index=0;
	static int32_t found_peak=0;

    static int32_t peak_locs[peaks_size] = {0};
    static int32_t pvc_index[peaks_size] = {0};

	static int32_t vt_i[peaks_size] = {0};
	static int32_t left_marg, right_marg, T1_length, T2_length, amp_sum=0, interval_sum=0, curr_interval;
	static float32_t T1_avg, T2_avg;

    static int32_t initialized = 0;

    if(initialized == 0)
    {
    	array_init(peak_locs,peaks_size);
    	array_init(lp_circ_buff,LP_size);
    	array_init(hp_circ_buff,HP_size);
    	array_init(diff_circ_buff,diff_size);
    	array_init(int_circ_buff,int_size);
    	array_init(highpass_5s,FS5);
    	array_init(int_5s,FS5);
    	array_init(T1,T1_max_length);
    	array_init(T2,T2_max_length);
        initialized = 1;
    }

    array_copy(signal_in_temp,signal_in,SENSOR_BUFFER);
    preprocessing(signal_in_temp,highpass,signal_temp,wavelet,wavelet_buff,lp_circ_buff,hp_circ_buff,diff_circ_buff,int_circ_buff);

		for(j=0; j<SENSOR_BUFFER; j++)
		{
			highpass_5s[indexWrap(hp_5s_index-j,FS5)]=highpass[j];
            bpf[j]=highpass[j];
			int_5s[indexWrap(hp_5s_index-j,FS5)]=signal_temp[j];
			signal_in_5s[indexWrap(hp_5s_index-j,FS5)]=signal_in[j];
			wavelet_5s[indexWrap(hp_5s_index-j,FS5)]=wavelet[j];
		}

		for(j=0; j<SENSOR_BUFFER; j++)
		{
			pantompkins(highpass_5s, int_5s, peak_locs, indexWrap(hp_5s_index-j+circ_buff_shift,FS5), index_curr-circ_buff_shift, &peaks_index, &highpass_5s_peak_index, &found_peak);
			if(found_peak==1)
			{
				prev_peak_loc=curr_peak_loc;
				curr_peak_loc=indexWrap(highpass_5s_peak_index+21,FS5);

				if(prev_peak_loc!=-1)
				{
					if((peak_locs[indexWrap(peaks_index-2, peaks_size)]-21)<signal_length_120s)
					{
						amp_sum+=signal_in_5s[prev_peak_loc];
						interval_sum+=peak_locs[indexWrap(peaks_index-1, peaks_size)]-peak_locs[indexWrap(peaks_index-2, peaks_size)];
						amp_mean=amp_sum/peaks_index;
						interval_mean=interval_sum/(peaks_index-1);
					}

					else if((peak_locs[indexWrap(peaks_index-2, peaks_size)]-21)>=signal_length_120s && template_found==0)
					{
						curr_interval=peak_locs[indexWrap(peaks_index-1, peaks_size)]-peak_locs[indexWrap(peaks_index-2, peaks_size)];
						generate_templates(signal_in_5s,wavelet_5s,prev_peak_loc,curr_peak_loc,curr_interval,T1,&T1_length,&T1_avg,T2,&T2_length,&T2_avg,&left_marg,&right_marg,&template_found,amp_mean,interval_mean);
					}

					else if((peak_locs[indexWrap(peaks_index-2, peaks_size)]-21)>signal_length_120s && template_found==1)
					{
						temp_match(signal_in_5s, prev_peak_loc, curr_peak_loc, T1, T1_length, T1_avg, T2, T2_length, T2_avg, left_marg, right_marg, zk_pvc, pvc_index, vt_i, &sendMessage, peak_locs, peaks_index-1);
						/*if(sendMessage==1)
						{
							int32_t j=prev_peak_loc, k;
							for(k=0; k < T2_max_length; k++)
							{
								toSend[k] = signal_in_5s[j];
								j=indexWrap(j+1,FS5);
							}
						}*/

					}
				}
				else
				{
					amp_sum+=signal_in_5s[curr_peak_loc];
				}

				found_peak=0;
			}
			index_curr++;
		}
		hp_5s_index=indexWrap(hp_5s_index-SENSOR_BUFFER,FS5);

        *detected = sendMessage;

        #ifdef MATLAB_MEX_FILE 
			for(j = 0; j < T1_max_length; j++){
				t1_db[j] = T1[j];
			}
			for(j = 0; j < T2_max_length; j++){
				t2_db[j] = T2[j];
			}
		#endif
        for(j = 0; j < peaks_size; j++){
            peak_index_out[j] = peak_locs[j];
            pvc_index_out[j] = pvc_index[j];
        }
}

#ifdef MATLAB_MEX_FILE 
#include <mex.h>
#include <string.h>
#include <stdio.h>
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    int32_t i = 0;
    int32_t d[SENSOR_BUFFER];
    int32_t bpf[SENSOR_BUFFER];
    int32_t peak_locs[peaks_size];
    int32_t pvc_index[peaks_size];    
    int32_t t1[T1_max_length];
    int32_t t2[T2_max_length];

    if(nrhs > 0){
        if(mxIsInt32(prhs[0])){
            if(mxGetM(prhs[0]) == 1 && mxGetN(prhs[0]) == SENSOR_BUFFER){
                memcpy(d, mxGetPr(prhs[0]), SENSOR_BUFFER*sizeof(uint32_t));
            }
            else{
                char errormsg[64];
                sprintf(errormsg, "Signal input wrong size.  Must be of size 1x%d.", SENSOR_BUFFER);
                mexErrMsgTxt(errormsg);           
            }
        }
        else{
            mexErrMsgTxt("Signal input is not of type 'int32'.");           
        }
    }
    else{
        mexErrMsgTxt("Not enough input arguments.");
    }

    arrhythmia_detection(d, &i, bpf, peak_locs, pvc_index, t1, t2);

    plhs[0] = mxCreateDoubleScalar(i);
    plhs[1] = mxCreateNumericMatrix(1, SENSOR_BUFFER, mxINT32_CLASS, mxREAL);
    plhs[2] = mxCreateNumericMatrix(1, peaks_size, mxINT32_CLASS, mxREAL);    
    plhs[3] = mxCreateNumericMatrix(1, peaks_size, mxINT32_CLASS, mxREAL);    
    plhs[4] = mxCreateNumericMatrix(1, T1_max_length, mxINT32_CLASS, mxREAL);
    plhs[5] = mxCreateNumericMatrix(1, T2_max_length, mxINT32_CLASS, mxREAL);

    memcpy(mxGetPr(plhs[1]), bpf, SENSOR_BUFFER*sizeof(uint32_t));
    memcpy(mxGetPr(plhs[2]), peak_locs, peaks_size*sizeof(uint32_t));
    memcpy(mxGetPr(plhs[3]), pvc_index, peaks_size*sizeof(uint32_t));
    memcpy(mxGetPr(plhs[4]), t1, T1_max_length*sizeof(uint32_t));
    memcpy(mxGetPr(plhs[5]), t2, T2_max_length*sizeof(uint32_t));
}
#endif

