#include "pan_tompkins.h"

void pantompkins(int32_t* highpass, int32_t* integration, int32_t* peak_locs, int32_t hp_5s_index, int32_t curr_index, int32_t* peaks_index, int32_t* hp_peak_loc, int32_t* found_peak)
{
	int32_t highpass_local_max_index, m_selected_RR, skip;
	static int32_t mean_RR2=0;
	static int32_t max_integration=0;
	static int32_t max_highpass=0;
	static int32_t SPKI=0;
	static int32_t NPKI=0;
	static int32_t THRESHOLD_I1=0;
	static int32_t THRESHOLD_I2=0;
	static int32_t SPKF=0;
	static int32_t NPKF=0;
	static int32_t THRESHOLD_F1=0;
	static int32_t THRESHOLD_F2=0;
	static int32_t prev_peak=0;
	static int32_t blank_count=0;
	static int32_t blank_flag=0;
	skip=0;

	if(curr_index<FS2 && curr_index>=0)
	{
		if(integration[hp_5s_index]>max_integration)
		{
			max_integration=integration[hp_5s_index];
		}

		if(highpass[hp_5s_index]>max_highpass)
		{
			max_highpass=highpass[hp_5s_index];
		}

		if(curr_index==FS2-1) //initialize thresholds
		{
			SPKI = max_integration/4;
			NPKI = max_integration/4;
			THRESHOLD_I1 = NPKI+((SPKI-NPKI)/4);
			THRESHOLD_I2 = THRESHOLD_I1/2;

			SPKF = max_highpass/4;
			NPKF = 0;
			THRESHOLD_F1 = NPKF+((SPKF-NPKF)/4);
			THRESHOLD_F2 = THRESHOLD_F1/2;
		}
	}

	else
	{
		if(blank_flag) //a potential peak has been detected, wait for 200 ms
		{
			if(blank_count<MS_200)
			{
				blank_count++;
			}
			else
			{
				*found_peak=1; //the potential peak has remained for 200 ms
				blank_count=0;
				blank_flag=0;
			}
		}
		//detect possible local maxima (strictly greater than one neighbor and greater than or equal to the other neighbor)
		if (((integration[hp_5s_index]>=integration[indexWrap(hp_5s_index-1,FS5)]) && (integration[hp_5s_index]>integration[indexWrap(hp_5s_index+1,FS5)]))||((integration[hp_5s_index]>integration[indexWrap(hp_5s_index-1,FS5)]) && (integration[hp_5s_index]>=integration[indexWrap(hp_5s_index+1,FS5)])))
		{
			highpass_local_max_index=locate_peaks_highpass(hp_5s_index, highpass);
			m_selected_RR=0;
			if (*peaks_index>=9) //calculate the most recent RR-interval average
			{
				m_selected_RR = RR_interval(peak_locs,*peaks_index,&mean_RR2,&THRESHOLD_I1,&THRESHOLD_F1);
			}
			lookback(peaks_index,peak_locs,&SPKF,&SPKI,integration,THRESHOLD_F2,THRESHOLD_I2,highpass,m_selected_RR,hp_5s_index,curr_index,&prev_peak);

			//  find noise and QRS peaks
			if (integration[hp_5s_index] >= THRESHOLD_I1)
			{
				if (*peaks_index>=1)
				{
					is_T_wave(peak_locs,*peaks_index,highpass[indexWrap(hp_5s_index+highpass_local_max_index,FS5)],&NPKF,&NPKI,integration,&skip,hp_5s_index,curr_index,*hp_peak_loc,highpass);
				}
				if (skip == 0)
				{
					if (highpass[indexWrap(hp_5s_index+highpass_local_max_index,FS5)] >= THRESHOLD_F1)
					{
						find_QRS(peak_locs,peaks_index,highpass_local_max_index,highpass[indexWrap(hp_5s_index+highpass_local_max_index,FS5)],&SPKF,&SPKI,integration,hp_5s_index,curr_index,hp_peak_loc,highpass,&blank_flag,&blank_count);
					}
				}
			}

			else if ((THRESHOLD_I2 <= integration[hp_5s_index]) && (integration[hp_5s_index]<THRESHOLD_I1))
			{
				NPKF = (highpass[indexWrap(hp_5s_index+highpass_local_max_index,FS5)] + (7*NPKF))/8;
				NPKI = (integration[hp_5s_index] + (7*NPKI))/8;
			}

			else if (integration[hp_5s_index] < THRESHOLD_I2)
			{
				NPKF = (highpass[indexWrap(hp_5s_index+highpass_local_max_index,FS5)] + (7*NPKF))/8;
				NPKI = (integration[hp_5s_index] + (7*NPKI))/8;
			}

			THRESHOLD_I1 = NPKI + (SPKI - NPKI)/4;
			THRESHOLD_I2 = THRESHOLD_I1/2;

			THRESHOLD_F1 = NPKF + (SPKF - NPKF)/4;
			THRESHOLD_F2 = THRESHOLD_F1/2;

			skip=0;
		}
	}
}
