/* Real-Time Electrocardiogram Monitoring
   Common code
   config.h - Function and struct for managing the project configuration file
   Calvin Walden
   2017-04-16
*/

#ifndef CONFIG_H
#define CONFIG_H

#include "rtecg.h"

/* Configuration file struct */
struct rtecg_cfg {
    /* Device properties */
    const char* device_name;
    int device_id;
    const char* patient_name;
    int patient_id;
    const char* patient_email;
    const char* physician_email;
    /* Software configuration */
    const char* rtecg_dir;
    const char* logfile_dir;
    const char* raw_logfile_dir;
    const char* plot_dir;
    const char* mail_bin;
    const char* gnuplot_bin;
};

extern struct rtecg_cfg rtecg_config;



/* configLoad: Load and parse a configuration file using libconfig calls,
   put contents into struct rtecg_cfg */
int configLoad(void);



#endif /* CONFIG_H */

