% AVR I2C Data acquisition simulator
% Real-Time Electrocardiogram Monitoring
% real-time-ecg/raspberry_pi/acquisition_daemon/avr-testing/generate_header.m
% Calvin Walden
% 2017-01-13

clear all;
close all;

raw_data_filename = '../../../raw_data/sensor_dsp/2017-02-09_01.dat';

% Read raw data
N = 361;
data = int32(dlmread(raw_data_filename, '\n', 1, 0));
data = data(1:N);

% Open file
filename = './raw_data.h';
f = fopen(filename, 'w+');
if (f < 0)
    disp('fopen() returned < 0');
    return;
end

% Write header
fprintf(f, ['/* raw_data.h: This file was automatically generated ' ...
            'by the MATLAB script \n   generate_header.m from the raw ' ...
            'data file:\n   ', raw_data_filename, '.\n\n*/\n\n']);
fprintf(f, '#ifndef RAW_DATA_H\n#define RAW_DATA_H\n\n');
fprintf(f, '#define N %d\n', N);
fprintf(f, 'const int raw_data[%d] = {\n', N);

% Write data

for n=1:N
    fprintf(f, '  %6.0i,\n', data(n));
end

% Write footer
fprintf(f, '};\n\n');
fprintf(f, '#endif /* RAW_DATA_H */\n');

fclose(f);

