/* Real-Time Electrocardiogram Monitoring
   Communication Daemon
   gnuplot.h - Software interface for calling gnuplot(1) to generate plots of 
   ECG data
   Calvin Walden
   2017-03-20
*/
#ifndef GNUPLOT_H
#define GNUPLOT_H



/* gnuplotPlotFile(): Given a logfile from which to pull data, generate a plot 
   its newest data, at the end of the file.
   Input: logfile (absolute path, file must exist) and pngfile (absolute path,
   file will be created)
   Output: Stored in file specified in pngfile
   Return: 0 on success, 1 on failure
*/
int gnuplotPlotFile(char* logfile, char* pngfile);



#endif /* GNUPLOT_H */
