/* Real-Time Electrocardiogram Monitoring
   Communication Daemon
   helper.h - Helper functions
   ECG data
   Calvin Walden
   2017-03-20
*/

#ifndef HELPER_H
#define HELPER_H

/* #define DEBUG_HELPER */



/* helperGetFreeSpace(): Get free space of the volume mounted at the path for
   directory using statvfs. Return values are in MiB.
   Input: directory: pathname to directory to run stat on
   Ouput: free: free space (free blocks X block size), in MiB
          total: total space (total blocks X block size), in MiB
   Return: 0 on success, 1 on failure.
*/
int helperGetFreeSpace(char* directory, int* free, int* total, int* percent_used);



/* helperGetISODateTime Get the current date and time string in an 
   ISO-8601-ish format 
   Input: buffer, which should be 20 characters long ("YYYY-MM-DD HH:MM:SS\0")
   Output: buffer (also)
   Return: *buffer, for convenience
*/
char* helperGetISODateTime(char* buffer);



/* helperGetISODate: Get the current date string in an ISO-8601-ish format
   ISO-8601-ish format 
   Input: buffer, which should be 11 characters long ("YYYY-MM-DD\0")
   Output: buffer (also)
   Return: *buffer, for convenience
*/
char* helperGetISODate(char* buffer);



#endif /* HELPER_H */
