/* Real-Time Electrocardiogram Monitoring
   Communication Daemon
   signalhandler.h - User signal handler and its setup function
   Calvin Walden
   2017-03-20
*/

#ifndef SIGNALHANDLER_H
#define SIGNALHANDLER_H

extern int sigusr1_flag;
extern int sigusr2_flag;



/* signalHandlerSetup(): Register handler, signalHandler(), for SIGUSR1 and 
   SIGUSR2 with the kernel
   Input: None
   Output: None
   Return: 0 on success, 1 on failure
*/
int signalHandlerSetup(void);



/* signalHandler(): This is called when SIGUSR1 or SIGUSR2 is received by the 
   daemon process. In both cases, the respective flag, a global variable, is 
   set, and the desired tasks are carried out by commLoop().
   Input: signal - number of the signal, defined in <signal.h>
   Output: None
   Return: None
*/
void signalHandler(int signal);

#endif /* SIGNALHANDLER_H */
