/*
 * ecg_interrupt.h
 *
 *  Created on: Jan 31, 2017
 *      Author: edward
 */

#ifndef INC_ECG_INTERRUPT_H_
#define INC_ECG_INTERRUPT_H_

#include <csl_intc.h>	//Requires setting '--algebraic' flag to compiler configuration

extern void VECSTART(void);

/*Function: initialize_interrupts
 * This functions disables and sets up interrupts.  Interrupts are not enabled at the end of the function
 * return 'True' if successful */
Bool initialize_interrupts(void);

/*Function: enable_interrupts
 * This function enables all interrupts
 * return 'True' if successful */
Bool enable_interrupts(void);

/*Function: disable_interrupts
 * This function disables all interrupts
 * return 'True' if successful */
Bool disable_interrupts(void);

interrupt void gpt0ISR(void);
interrupt void sarISR(void);
interrupt void uartISR(void);


#endif /* INC_ECG_INTERRUPT_H_ */
