/*
 * ecg_gpio.c
 *
 *  Created on: Jan 31, 2017
 *      Author: edward
 */

#include "ecg_gpio.h"
#include "ecg.h"

GPIO_Handle	hGPIO;

Bool initialize_gpio(void){

	CSL_GpioPinConfig config;
	static CSL_GpioObj GpioObj;

	//Setup GPIO pins
	hGPIO = GPIO_open(&GpioObj, &status);
	config.trigger  = CSL_GPIO_TRIG_FALLING_EDGE;
	config.direction = CSL_GPIO_DIR_OUTPUT;
	config.pinNum = CSL_GPIO_PIN13;		//GPIO 13
	GPIO_configBit (hGPIO, &config);
	config.pinNum = CSL_GPIO_PIN14;		//Blue Led
	GPIO_configBit (hGPIO, &config);
	config.pinNum = CSL_GPIO_PIN15;		//Orange Led
	GPIO_configBit (hGPIO, &config);
	config.pinNum = CSL_GPIO_PIN16;		//Red Led
	GPIO_configBit (hGPIO, &config);
	config.pinNum = CSL_GPIO_PIN17;		//Green Led
	GPIO_configBit (hGPIO, &config);

	//Set initial GPIO states
	status = GPIO_write(hGPIO, CSL_GPIO_PIN14, 1);	//Blue Led
	status = GPIO_write(hGPIO, CSL_GPIO_PIN15, 1);	//Orange Led
	status = GPIO_write(hGPIO, CSL_GPIO_PIN16, 1);	//Red Led
	status = GPIO_write(hGPIO, CSL_GPIO_PIN17, 1);	//Green Led

	return TRUE;
}


Bool display_int_led(Uint16 num){
	status = GPIO_write(hGPIO, CSL_GPIO_PIN14, (~num >> 0) & 0x1);	//Blue Led
	status = GPIO_write(hGPIO, CSL_GPIO_PIN15, (~num >> 1) & 0x1);	//Orange Led
	status = GPIO_write(hGPIO, CSL_GPIO_PIN16, (~num >> 2) & 0x1);	//Red Led
	status = GPIO_write(hGPIO, CSL_GPIO_PIN17, (~num >> 3) & 0x1);	//Green Led

	return TRUE;
}
