/*
 * ecg_gpt.c
 *
 *  Created on: Jan 31, 2017
 *      Author: edward
 */

#include "ecg_timer.h"
#include "ecg.h"

CSL_Handle hGpt0;

/*Function: initialize_timers
 * This functions sets up and enables the general purpose timers
 * return 'True' if successful
 */
Bool initialize_timers(void){

	CSL_Config hwTim0Config;
	static CSL_GptObj gptObj;
	Uint32 		SYSCLK = getSysClk();

	// Open the CSL GPT module
	hGpt0 = GPT_open (GPT_0, &gptObj, &status);
	if((NULL == hGpt0) || (CSL_SOK != status))
	{
		return (0);
	}

	// Reset the GPT module
	status = GPT_reset(hGpt0);
	if(CSL_SOK != status)
	{
		return (0);
	}

	// Configure GPT
	hwTim0Config.autoLoad=GPT_AUTO_ENABLE ;
	hwTim0Config.ctrlTim = GPT_TIMER_ENABLE;
	hwTim0Config.preScaleDiv = GPT_PRE_SC_DIV_0;
	//Period=SYSCLK(hz) / clock divider (2^(1+GPT_PRE_SC_DIV_0)) / sampling frequency (360Hz)
	Uint32 timerPeriod = (SYSCLK*1000) / 2 / SAMP_FREQ;
	hwTim0Config.prdLow = timerPeriod & 0xFFFF;
	hwTim0Config.prdHigh = (timerPeriod >> 16) & 0xFFFF;
	status = GPT_config(hGpt0, &hwTim0Config);
	if(CSL_SOK != status)
	{
		return (0);
	}

	//Start Timer 0
	GPT_start(hGpt0);

	return(1);
}


