:: MAKE_BOOT_IMAGE.bat: Call hex55.exe to produce the flash memory image for the TI C5515 DSP.
:: This relies on the paths in variables HEX55, INPUT_REL, and OUTPUT_REL to be set correctly.
@ECHO off

SETLOCAL

:: Configuration for the script. The HEX55 variable is what might
:: need to be changed if the compiler is updated.

SET HEX55=C:\ti\ccsv6\tools\compiler\c5500_4.4.1\bin\hex55.exe
SET INPUT_REL=.\ti_c5515\real-time-ecg\Debug\real-time-ecg.out
SET OUTPUT_REL=.\ti_c5515\real-time-ecg\Debug\real-time-ecg.bin

:: Check if the binary exists. If not, exit and tell the user to 
:: manually update this script.
IF NOT EXIST %HEX55% (
  ECHO.
  ECHO Could not find hex55.exe. Check the path in this script ^(variable "HEX55"^) and update it 
  ECHO if you are a version of the TI compiler newer than v4.4.1.

  EXIT /B
)

:: Resolve relative paths
SET INPUT= "%cd%%INPUT_REL%"
SET OUTPUT= "%cd%%OUTPUT_REL%"

%HEX55% -i %INPUT% -o %OUTPUT% -boot -v5505 -b -serial8

ENDLOCAL

